=== debian/tests/control ===
Tests: 
 001-essential-binaries-and-config-files-should-be-present,
Depends: dotnet8
Restrictions: superficial

Tests:
 002-cli-metadata-should-be-correct,
Depends: dotnet8
Restrictions: skippable

Tests:
 003-global-json-should-be-detected,
 004-console-template-should-build-and-run,
 005-dotnet-help-should-show-output,
 006-dotnet-project-management-cli-should-work,
 007-example-fsharp-script-output-should-equal-expected-values,
 008-building-hello-world-for-all-supported-rids-should-work,
 009-dotnet-runtime-json-contains-ubuntu-rids,
Depends: dotnet8

Tests: 
 010-dotnet-xunit-tests-should-work,
 011-nuget-cli-should-be-able-to-consume-packages-from-nuget-gallery,
Depends: dotnet8
Restrictions: needs-internet

Tests: 
 012-crossbuild-for-windows-x64-should-run,
Depends: dotnet8, wine
Architecture: amd64
Restrictions: flaky

Tests:
 013-dotnet6-and-dotnet7-and-dotnet8-should-work-together,
Depends: dotnet6, dotnet7, dotnet8
