=== debian/watch ===
version=4
# watch for 8.0.X[X[-TEXT.X.XXXXX.X]] pattern:
# watch for 8.0.100-preview.1; 8.0.100-preview.2; 8.0.100-preview.3:
opts="mode=git,repack,compression=xz,dversionmangle=s/^8\.0\.(1\d\d)-//,uversionmangle=s/^8\.0\.100/8.0.0/;s/-([a-z]+)\./~$1/" \
git@github.com:dotnet/dotnet.git \
^refs/tags/v(8\.0\.\d{1,3}(?:-[a-z]+\.\d+)?).*$ \
debian \
debian/watch-script.sh
