## dotnet8 8.0.103

=== runtime/src/mono/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,9 @@
   if(EXISTS ${CLR_SOURCELINK_FILE_PATH})
     add_link_options("/sourcelink:${CLR_SOURCELINK_FILE_PATH}")
   endif()
+
+  # FIXME: Remove the line below when https://github.com/dotnet/runtime/issues/91249 is fixed.
+  add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/wd4244>) # conversion from 'type1' to 'type2', possible loss of data
 endif(MSVC)
 
 set(CROSS_ROOTFS $ENV{ROOTFS_DIR})
@@ -363,11 +366,3 @@
 # HOST ARCH CHECKS
 ######################################
 
-if(NOT "${CMAKE_OSX_ARCHITECTURES}" STREQUAL "")
-  set(CMAKE_SYSTEM_PROCESSOR "${CMAKE_OSX_ARCHITECTURES}")
-endif()
-
-if(NOT "${MSVC_C_ARCHITECTURE_ID}" STREQUAL "")
-  set(CMAKE_SYSTEM_PROCESSOR "${MSVC_C_ARCHITECTURE_ID}")
-endif()
-
